import static org.junit.jupiter.api.Assertions.*;

import org.junit.jupiter.api.Test;

class SellOrderTest {

	@Test
	void sellTradeTest() {
		Customer c = new Customer("c1");
		Stock stock = new Stock("Apple");
		SellOrder sellOrder = new SellOrder(1, c, stock, 100, 200);
		assertEquals(sellOrder.getCustomer().getId(), c.getId());
		assertEquals(sellOrder.getPrice(), 200);
		assertEquals(sellOrder.getQty(), 100);
		assertEquals(sellOrder.getTime(), 1);
		assertEquals(sellOrder.getType(), "SELL");	
		assertEquals(sellOrder.getStock().getName(), "Apple");
	}

	@Test
	void equalityTest() {
		Customer c1 = new Customer("c1");
		Customer c2 = new Customer("c2");
		Stock s1 = new Stock("Apple");
		Stock s2 = new Stock("Google");
		BuyOrder bt1 = new BuyOrder(1, c1, s1, 100, 200);
		SellOrder st1 = new SellOrder(1, c1, s1, 100, 200);
		
		// checking if a two objects created with exact same arguments
		// are indeed equal
		assertEquals(new SellOrder(1, c1, s1, 100, 200), st1);
		assertNotEquals(new SellOrder(1, c1, s1, 100, 300), st1);
		
		// checking SellTrade and BuyTrade are not equal
		assertNotEquals(bt1, st1);
	}

}
